Handle Management
Globus FTP Client API
Collaboration diagram for Handle Management:

## Data Structures

struct | globus_i_ftp_client_data_target_t
| Data connection caching information. More...
struct | globus_i_ftp_client_handle_t
| FTP Client handle implementation. More...

## Typedefs

typedef struct globus_i_ftp_client_handle_t * | globus_ftp_client_handle_t
| FTP Client Handle.An FTP client handle is used to associate state with a group of operations. Handles can have attributes associated with them. All FTP operations take a handle pointer as a parameter. More...
typedef struct globus_i_ftp_client_handle_t | globus_i_ftp_client_handle_t
| FTP Client handle implementation.

## Initialize

globus_result_t | globus_ftp_client_handle_init (globus_ftp_client_handle_t *handle, globus_ftp_client_handleattr_t *attr)

## Destroy

globus_result_t | globus_ftp_client_handle_destroy (globus_ftp_client_handle_t *handle)

## URL Caching

globus_result_t | globus_ftp_client_handle_cache_url_state (globus_ftp_client_handle_t *handle, const char *url)
globus_result_t | globus_ftp_client_handle_flush_url_state (globus_ftp_client_handle_t *handle, const char *url)

## User Pointer

globus_result_t | globus_ftp_client_handle_set_user_pointer (globus_ftp_client_handle_t *handle, void *user_pointer)
globus_result_t | globus_ftp_client_handle_get_user_pointer (const globus_ftp_client_handle_t *handle, void **user_pointer)

## Plugins

globus_result_t | globus_ftp_client_handle_add_plugin (globus_ftp_client_handle_t *handle, globus_ftp_client_plugin_t *plugin)
globus_result_t | globus_ftp_client_handle_remove_plugin (globus_ftp_client_handle_t *handle, globus_ftp_client_plugin_t *plugin)

## Detailed Description

Create/Destroy/Modify an FTP Client Handle.

Within the Globus FTP Client Library, all FTP operations require a handle parameter. Currently, only one FTP operation may be in progress at once per FTP handle. FTP connections may be cached between FTP operations, for improved performance.

This section defines operations to create and destroy FTP Client handles, as well as to modify handles' connection caches.

## Typedef Documentation

typedef struct globus_i_ftp_client_handle_t* globus_ftp_client_handle_t

FTP Client Handle.An FTP client handle is used to associate state with a group of operations. Handles can have attributes associated with them. All FTP operations take a handle pointer as a parameter.

See also
  globus_ftp_client_handle_init(), globus_ftp_client_handle_destroy(), globus_ftp_client_handleattr_t

## Function Documentation

globus_result_t globus_ftp_client_handle_add_plugin | ( | globus_ftp_client_handle_t * | handle,
|  | globus_ftp_client_plugin_t * | plugin
| ) |  |

Add a plugin to an FTP client handle.

This function adds a plugin to an FTP client handle after it has been created. Plugins may be added to an ftp client handle whenever an operation is not in progress. The plugin will be appended to the list of plugins present in the handle, and will be invoked during any subsequent operations processed with this handle.

Only one instance of a particular plugin may be added to a particular handle.

Plugins may be removed from a handle by calling globus_ftp_client_remove_plugin().

Parameters

  handle | The FTP client handle to set or query.
  plugin | A pointer to the plugin structure to add to this handle.

See also
  globus_ftp_client_remove_plugin(), globus_ftp_clent_handleattr_add_plugin(), globus_ftp_clent_handleattr_remove_plugin()

globus_result_t globus_ftp_client_handle_cache_url_state | ( | globus_ftp_client_handle_t * | handle,
|  | const char * | url
| ) |  |

Cache connections to an FTP server.

Explicitly cache connections to URL server in an FTP handle. When an URL is cached, the client library will not close the connection to the URL server after a file transfer completes.

Parameters

  handle | Handle which will contain a cached connection to the URL server.
  url | The URL of the FTP or GSIFTP server to cache.

See also
  globus_ftp_client_flush_url_state()

globus_result_t globus_ftp_client_handle_destroy | ( | globus_ftp_client_handle_t * | handle | ) |

Destroy a client FTP handle.

A FTP client handle may not be destroyed if a get, put, or third-party transfer is in progress.

Parameters

  handle | The handle to be destroyed.

See also
  globus_ftp_client_handle_init()

globus_result_t globus_ftp_client_handle_flush_url_state | ( | globus_ftp_client_handle_t * | handle,
|  | const char * | url
| ) |  |

Remove a cached connection from the FTP client handle.

Explicitly remove a cached connection to an FTP server from the FTP handle. If an idle connection to an FTP server exists, it will be closed.

Parameters

  handle | Handle which will contain a cached connection to the URL server.
  url | The URL of the FTP or GSIFTP server to cache.

globus_result_t globus_ftp_client_handle_init | ( | globus_ftp_client_handle_t * | handle,
|  | globus_ftp_client_handleattr_t * | attr
| ) |  |

Initialize a client FTP handle.

Initialize an FTP handle which can be used in subsequent get, put, or transfer requests. A handle may have at most one get, put, or third-party transfer in progress.

Parameters

  handle | The handle to be initialized.
  attr | Initial attributes to be used to create this handle.

See also
  globus_ftp_client_handle_destroy()

globus_result_t globus_ftp_client_handle_remove_plugin | ( | globus_ftp_client_handle_t * | handle,
|  | globus_ftp_client_plugin_t * | plugin
| ) |  |

Remove a plugin to an FTP client handle.

This function removes a plugin from an FTP client handle after it has been created. Plugins may be removed from an ftp client handle whenever an operation is not in progress. The plugin will be removed from the list of plugins, and will not be used during any subsequent operations processed with this handle.

This function can remove plugins which were added at handle initialization time or by calling globus_ftp_client_handle_add_plugin().

Parameters

  handle | The FTP client handle to set or query.
  plugin | A pointer to the plugin structure to remove from this handle.

See also
  globus_ftp_client_add_plugin(), globus_ftp_clent_handleattr_add_plugin(), globus_ftp_clent_handleattr_remove_plugin()

globus_result_t globus_ftp_client_handle_set_user_pointer | ( | globus_ftp_client_handle_t * | handle,
|  | void * | user_pointer
| ) |  |

Set/Get the user pointer field from an ftp client handle.

The user pointer is provided to all the user of the FTP client library to assocate a pointer to any application-specific data to an FTP client handle. This pointer is never internally used by the client library.

Parameters

  handle | The FTP client handle to set or query.
  user_pointer | The value of the user pointer field.

Note
  Access to the user_pointer are not synchronized, the user must take care to make sure that multiple threads are not modifying it's value.